package DE.uni_hamburg.informatik.tech.JavaFSM;
import java.awt.*;
import java.util.*;

/**
* <IMG SRC="../doku/images/logo_klein.gif" ALT="JavaFSM"><BR>
* Editor Fenster mit Zeichenfl&auml;che, Buttons, Statuszeile, etc.
*/
class EditFrame extends Frame {
	private  FSM fsm;
	private boolean mealy_machine;				// ob es ein Mealy oder Moore FSM ist
	/** benutzte Instanz der Zeichenfl&auml;che */
	public  EditCanvas editCanvas;				// das Canvas, in dem die FSM konstruiert wird
	private Statuszeile status;					// Statuszeile ganz unten im Fenster
	private Panel buttonPanel;					// Panel, das die Modus-Buttons enthlt
	private Panel button2Panel;					// Panel, das den "Test"-Button enthlt
	private Panel dataPanel, nonePanel, zustandMoorePanel;				// die verschiedenen CardLayout-Panels
	private Panel zustandMealyPanel, transitionPanel, kommentarPanel;	// ...
	private Scrollbar HBar,VBar;				// Scrollbars fr das editCanvas
	private Button buttonMove;					// die verschiedenen Modus-Buttons ...
	private Button buttonZustand;
	private Button buttonTransition;
	private Button buttonKommentar;
	private Button buttonDelete;
	private Button buttonStart;
//	private Button buttonPrint;
	private Button buttonTest;
	private Button kommentarOK;
	private Label noneLabel, zustMoLabel, zustMeLabel, transLabel, kommentarLabel; // Labels fr die CardLayout-Panels
	private TextField zustMoField, zustMeField, outField, transField;	// TextFileds fr die CardLayout-Panels
	private TextArea kommentarArea;				// TextArea fr Kommentare
	private List signalListMo, signalListMe;	// List-Box fr Transitionen im CardLayout-Panel
	private CheckboxGroup chkBoxGrp;			// Radio-CheckBoxes bei Moore-FSM's zur Output-Eingabe
	private Checkbox lowChkBox,highChkBox;		// dazu die CheckBoxes
	private Font plainFont,boldFont;			// Fonts fr Modus-Buttons (boldFont zeigt aktiven Modus)
	private CardLayout card;					// Grund-Panel ist dataPanel; darauf kommen none-, zustand- und transitionPanel

	/** Breite der Zeichenfl&auml;che */
	public final static int VirtWidth = 1000;	// Gre des Zeichenbereiches
	/** H&ouml;he der Zeichenfl&auml;che */
	public final static int VirtHeight = 1000;

	/** 
	* Konstruktor
	* @param title Fenstertitel (String)
	* @param Fsm endlicher Automat, der editiert werden soll (FSM)
	*/
	public EditFrame(String title, FSM Fsm) {
		super(title);
		this.setBackground(Color.lightGray);
		mealy_machine = true;
	/* Parameter sichern */
		fsm = Fsm;
	/* Fonts fr Modus-Buttons */
		plainFont = new Font("Helvetica",Font.PLAIN,12);
		boldFont = new Font("Helvetica",Font.BOLD,13);

	/* LayoutManager setzen */
		card = new CardLayout();
		GridBagLayout gridbag = new GridBagLayout();
		GridBagConstraints gridcon = new GridBagConstraints();
		Insets ins = new Insets(0,0,0,0);
		this.setLayout(gridbag);

	/* das Panel fr die Modus-Buttons */
		buttonPanel = new Panel3D(false);
		buttonPanel.setLayout(gridbag);
		gridcon.anchor		= GridBagConstraints.CENTER;
		gridcon.fill		= GridBagConstraints.HORIZONTAL;
		gridcon.weightx		= 0.0;
		gridcon.weighty		= 0.0;
		gridcon.gridx		= 0;
		gridcon.gridy		= 0;
		gridcon.gridwidth	= 1;
		gridcon.gridheight	= 1;
		ins.top				= 5;
		ins.bottom			= 0;
		ins.left			= 5;
		ins.right			= 0;
		gridcon.insets		= ins;
		gridbag.setConstraints(buttonPanel,gridcon);

		buttonMove = new Button("Bewegen");
		buttonMove.setFont(boldFont);
		gridcon.anchor		= GridBagConstraints.CENTER;
		gridcon.fill		= GridBagConstraints.BOTH;
		gridcon.weightx		= 1.0;
		gridcon.weighty		= 0.0;
		gridcon.gridx		= 0;
		gridcon.gridy		= 0;
		gridcon.gridwidth	= 1;
		gridcon.gridheight	= 1;
		ins.top				= 5;
		ins.bottom			= 0;
		ins.left			= 5;
		ins.right			= 5;
		gridcon.insets		= ins;
		gridbag.setConstraints(buttonMove,gridcon);

		buttonZustand = new Button("Zustand");
		buttonZustand.setFont(plainFont);
		gridcon.anchor		= GridBagConstraints.CENTER;
		gridcon.fill		= GridBagConstraints.BOTH;
		gridcon.weightx		= 1.0;
		gridcon.weighty		= 0.0;
		gridcon.gridx		= 0;
		gridcon.gridy		= 1;
		gridcon.gridwidth	= 1;
		gridcon.gridheight	= 1;
		ins.top				= 5;
		ins.bottom			= 0;
		ins.left			= 5;
		ins.right			= 5;
		gridcon.insets		= ins;
		gridbag.setConstraints(buttonZustand,gridcon);

		buttonTransition = new Button("Transition");
		buttonTransition.setFont(plainFont);
		gridcon.anchor		= GridBagConstraints.CENTER;
		gridcon.fill		= GridBagConstraints.BOTH;
		gridcon.weightx		= 1.0;
		gridcon.weighty		= 0.0;
		gridcon.gridx		= 0;
		gridcon.gridy		= 2;
		gridcon.gridwidth	= 1;
		gridcon.gridheight	= 1;
		ins.top				= 5;
		ins.bottom			= 0;
		ins.left			= 5;
		ins.right			= 5;
		gridcon.insets		= ins;
		gridbag.setConstraints(buttonTransition,gridcon);

		buttonKommentar = new Button("Kommentar");
		buttonKommentar.setFont(plainFont);
		gridcon.anchor		= GridBagConstraints.CENTER;
		gridcon.fill		= GridBagConstraints.BOTH;
		gridcon.weightx		= 1.0;
		gridcon.weighty		= 0.0;
		gridcon.gridx		= 0;
		gridcon.gridy		= 3;
		gridcon.gridwidth	= 1;
		gridcon.gridheight	= 1;
		ins.top				= 5;
		ins.bottom			= 0;
		ins.left			= 5;
		ins.right			= 5;
		gridcon.insets		= ins;
		gridbag.setConstraints(buttonKommentar,gridcon);

		buttonDelete = new Button("Lschen");
		buttonDelete.setFont(plainFont);
		gridcon.anchor		= GridBagConstraints.CENTER;
		gridcon.fill		= GridBagConstraints.BOTH;
		gridcon.weightx		= 1.0;
		gridcon.weighty		= 0.0;
		gridcon.gridx		= 0;
		gridcon.gridy		= 4;
		gridcon.gridwidth	= 1;
		gridcon.gridheight	= 1;
		ins.top				= 5;
		ins.bottom			= 0;
		ins.left			= 5;
		ins.right			= 5;
		gridcon.insets		= ins;
		gridbag.setConstraints(buttonDelete,gridcon);

		buttonStart = new Button("Startzustand");
		buttonStart.setFont(plainFont);
		gridcon.anchor		= GridBagConstraints.CENTER;
		gridcon.fill		= GridBagConstraints.BOTH;
		gridcon.weightx		= 1.0;
		gridcon.weighty		= 0.0;
		gridcon.gridx		= 0;
		gridcon.gridy		= 5;
		gridcon.gridwidth	= 1;
		gridcon.gridheight	= 1;
		ins.top				= 5;
		ins.bottom			= 5;
		ins.left			= 5;
		ins.right			= 5;
		gridcon.insets		= ins;
		gridbag.setConstraints(buttonStart,gridcon);

/*		buttonPrint = new Button("Drucken");
		buttonPrint.setFont(plainFont);
		gridcon.anchor		= GridBagConstraints.CENTER;
		gridcon.fill		= GridBagConstraints.BOTH;
		gridcon.weightx		= 1.0;
		gridcon.weighty		= 0.0;
		gridcon.gridx		= 0;
		gridcon.gridy		= 6;
		gridcon.gridwidth	= 1;
		gridcon.gridheight	= 1;
		ins.top				= 5;
		ins.bottom			= 5;
		ins.left			= 5;
		ins.right			= 5;
		gridcon.insets		= ins;
		gridbag.setConstraints(buttonPrint,gridcon);	*/

	/* das Panel, das nur den "Test" Button enthlt */
		button2Panel = new Panel3D(false);
		button2Panel.setLayout(gridbag);
		gridcon.anchor		= GridBagConstraints.CENTER;
		gridcon.fill		= GridBagConstraints.HORIZONTAL;
		gridcon.weightx		= 0.0;
		gridcon.weighty		= 0.0;
		gridcon.gridx		= 0;
		gridcon.gridy		= 1;
		gridcon.gridwidth	= 1;
		gridcon.gridheight	= 1;
		ins.top				= 5;
		ins.bottom			= 0;
		ins.left			= 5;
		ins.right			= 0;
		gridcon.insets		= ins;
		gridbag.setConstraints(button2Panel,gridcon);

		buttonTest = new Button("FSM testen");
		buttonTest.setFont(plainFont);
		gridcon.anchor		= GridBagConstraints.CENTER;
		gridcon.fill		= GridBagConstraints.BOTH;
		gridcon.weightx		= 1.0;
		gridcon.weighty		= 0.0;
		gridcon.gridx		= 0;
		gridcon.gridy		= 0;
		gridcon.gridwidth	= 1;
		gridcon.gridheight	= 1;
		ins.top				= 5;
		ins.bottom			= 5;
		ins.left			= 5;
		ins.right			= 5;
		gridcon.insets		= ins;
		gridbag.setConstraints(buttonTest,gridcon);

	/* das Basis-CardLayout-Panel fr die Details (none,Zustand,Transition) */
		dataPanel = new Panel();
		dataPanel.setLayout(card);
		gridcon.anchor		= GridBagConstraints.NORTH;
		gridcon.fill		= GridBagConstraints.BOTH;
		gridcon.weightx		= 0.0;
		gridcon.weighty		= 1.0;
		gridcon.gridx		= 0;
		gridcon.gridy		= 2;
		gridcon.gridwidth	= 1;
		gridcon.gridheight	= 1;
		ins.top				= 5;
		ins.bottom			= 2;
		ins.left			= 5;
		ins.right			= 0;
		gridcon.insets		= ins;
		gridbag.setConstraints(dataPanel,gridcon);

	/* das CardLayout-Panel wenn nichts selektiert ist */
		nonePanel = new Panel3D(false);
		nonePanel.setLayout(gridbag);
		gridcon.anchor		= GridBagConstraints.NORTH;
		gridcon.fill		= GridBagConstraints.BOTH;
		gridcon.weightx		= 0.0;
		gridcon.weighty		= 1.0;
		gridcon.gridx		= 0;
		gridcon.gridy		= 0;
		gridcon.gridwidth	= 1;
		gridcon.gridheight	= 1;
		ins.top				= 2;
		ins.bottom			= 2;
		ins.left			= 2;
		ins.right			= 2;
		gridcon.insets		= ins;
		gridbag.setConstraints(nonePanel,gridcon);

		noneLabel = new Label("Nichts selektiert",Label.CENTER);
		noneLabel.setFont(boldFont);
		gridcon.anchor		= GridBagConstraints.NORTH;
		gridcon.fill		= GridBagConstraints.HORIZONTAL;
		gridcon.weightx		= 1.0;
		gridcon.weighty		= 1.0;
		gridcon.gridx		= 0;
		gridcon.gridy		= 0;
		gridcon.gridwidth	= 1;
		gridcon.gridheight	= 1;
		ins.top				= 5;
		ins.bottom			= 0;
		ins.left			= 5;
		ins.right			= 5;
		gridcon.insets		= ins;
		gridbag.setConstraints(noneLabel,gridcon);

	/* das CardLayout-Panel wenn ein Zustand selektiert ist */
		zustandMealyPanel = new Panel3D(false);
		zustandMealyPanel.setLayout(gridbag);
		gridcon.anchor		= GridBagConstraints.NORTH;
		gridcon.fill		= GridBagConstraints.BOTH;
		gridcon.weightx		= 0.0;
		gridcon.weighty		= 1.0;
		gridcon.gridx		= 0;
		gridcon.gridy		= 0;
		gridcon.gridwidth	= 1;
		gridcon.gridheight	= 1;
		ins.top				= 2;
		ins.bottom			= 2;
		ins.left			= 2;
		ins.right			= 2;
		gridcon.insets		= ins;
		gridbag.setConstraints(zustandMealyPanel,gridcon);

		zustMeLabel = new Label("Zustand",Label.CENTER);
		zustMeLabel.setFont(boldFont);
		gridcon.anchor		= GridBagConstraints.CENTER;
		gridcon.fill		= GridBagConstraints.HORIZONTAL;
		gridcon.weightx		= 1.0;
		gridcon.weighty		= 0.0;
		gridcon.gridx		= 0;
		gridcon.gridy		= 0;
		gridcon.gridwidth	= 1;
		gridcon.gridheight	= 1;
		ins.top				= 5;
		ins.bottom			= 0;
		ins.left			= 5;
		ins.right			= 5;
		gridcon.insets		= ins;
		gridbag.setConstraints(zustMeLabel,gridcon);

		zustMeField = new TextField(12);
		zustMeField.setFont(plainFont);
		gridcon.anchor		= GridBagConstraints.CENTER;
		gridcon.fill		= GridBagConstraints.HORIZONTAL;
		gridcon.weightx		= 1.0;
		gridcon.weighty		= 0.0;
		gridcon.gridx		= 0;
		gridcon.gridy		= 1;
		gridcon.gridwidth	= 1;
		gridcon.gridheight	= 1;
		ins.top				= 5;
		ins.bottom			= 0;
		ins.left			= 5;
		ins.right			= 5;
		gridcon.insets		= ins;
		gridbag.setConstraints(zustMeField,gridcon);

		signalListMe = new List(20,false);
		signalListMe.setFont(plainFont);
		gridcon.anchor		= GridBagConstraints.CENTER;
		gridcon.fill		= GridBagConstraints.BOTH;
		gridcon.weightx		= 1.0;
		gridcon.weighty		= 1.0;
		gridcon.gridx		= 0;
		gridcon.gridy		= 2;
		gridcon.gridwidth	= 1;
		gridcon.gridheight	= 1;
		ins.top				= 5;
		ins.bottom			= 0;
		ins.left			= 5;
		ins.right			= 5;
		gridcon.insets		= ins;
		gridbag.setConstraints(signalListMe,gridcon);

		outField = new TextField(12);
		outField.setFont(plainFont);
		gridcon.anchor		= GridBagConstraints.NORTH;
		gridcon.fill		= GridBagConstraints.HORIZONTAL;
		gridcon.weightx		= 1.0;
		gridcon.weighty		= 0.0;
		gridcon.gridx		= 0;
		gridcon.gridy		= 3;
		gridcon.gridwidth	= 1;
		gridcon.gridheight	= 1;
		ins.top				= 5;
		ins.bottom			= 5;
		ins.left			= 5;
		ins.right			= 5;
		gridcon.insets		= ins;
		gridbag.setConstraints(outField,gridcon);

	/* das gleiche Panel nochmal, aber anstatt eines TextFields (ganz unten) zwei radio-boxes */
		zustandMoorePanel = new Panel3D(false);
		zustandMoorePanel.setLayout(gridbag);
		gridcon.anchor		= GridBagConstraints.NORTH;
		gridcon.fill		= GridBagConstraints.BOTH;
		gridcon.weightx		= 0.0;
		gridcon.weighty		= 1.0;
		gridcon.gridx		= 0;
		gridcon.gridy		= 0;
		gridcon.gridwidth	= 1;
		gridcon.gridheight	= 1;
		ins.top				= 2;
		ins.bottom			= 2;
		ins.left			= 2;
		ins.right			= 2;
		gridcon.insets		= ins;
		gridbag.setConstraints(zustandMoorePanel,gridcon);

		zustMoLabel = new Label("Zustand",Label.CENTER);
		zustMoLabel.setFont(boldFont);
		gridcon.anchor		= GridBagConstraints.CENTER;
		gridcon.fill		= GridBagConstraints.HORIZONTAL;
		gridcon.weightx		= 1.0;
		gridcon.weighty		= 0.0;
		gridcon.gridx		= 0;
		gridcon.gridy		= 0;
		gridcon.gridwidth	= 2;
		gridcon.gridheight	= 1;
		ins.top				= 5;
		ins.bottom			= 0;
		ins.left			= 5;
		ins.right			= 5;
		gridcon.insets		= ins;
		gridbag.setConstraints(zustMoLabel,gridcon);

		zustMoField = new TextField(12);
		zustMoField.setFont(plainFont);
		gridcon.anchor		= GridBagConstraints.CENTER;
		gridcon.fill		= GridBagConstraints.HORIZONTAL;
		gridcon.weightx		= 1.0;
		gridcon.weighty		= 0.0;
		gridcon.gridx		= 0;
		gridcon.gridy		= 1;
		gridcon.gridwidth	= 2;
		gridcon.gridheight	= 1;
		ins.top				= 5;
		ins.bottom			= 0;
		ins.left			= 5;
		ins.right			= 5;
		gridcon.insets		= ins;
		gridbag.setConstraints(zustMoField,gridcon);

		signalListMo = new List(20,false);
		signalListMo.setFont(plainFont);
		gridcon.anchor		= GridBagConstraints.CENTER;
		gridcon.fill		= GridBagConstraints.BOTH;
		gridcon.weightx		= 1.0;
		gridcon.weighty		= 1.0;
		gridcon.gridx		= 0;
		gridcon.gridy		= 2;
		gridcon.gridwidth	= 2;
		gridcon.gridheight	= 1;
		ins.top				= 5;
		ins.bottom			= 0;
		ins.left			= 5;
		ins.right			= 5;
		gridcon.insets		= ins;
		gridbag.setConstraints(signalListMo,gridcon);

		chkBoxGrp = new CheckboxGroup();
		lowChkBox = new Checkbox("0",chkBoxGrp,true);
		lowChkBox.setFont(plainFont);
		gridcon.anchor		= GridBagConstraints.NORTH;
		gridcon.fill		= GridBagConstraints.HORIZONTAL;
		gridcon.weightx		= 0.5;
		gridcon.weighty		= 0.0;
		gridcon.gridx		= 0;
		gridcon.gridy		= 3;
		gridcon.gridwidth	= 1;
		gridcon.gridheight	= 1;
		ins.top				= 5;
		ins.bottom			= 5;
		ins.left			= 5;
		ins.right			= 5;
		gridcon.insets		= ins;
		gridbag.setConstraints(lowChkBox,gridcon);

		highChkBox = new Checkbox("1",chkBoxGrp,false);
		highChkBox.setFont(plainFont);
		gridcon.anchor		= GridBagConstraints.NORTH;
		gridcon.fill		= GridBagConstraints.HORIZONTAL;
		gridcon.weightx		= 0.5;
		gridcon.weighty		= 0.0;
		gridcon.gridx		= 1;
		gridcon.gridy		= 3;
		gridcon.gridwidth	= 1;
		gridcon.gridheight	= 1;
		ins.top				= 5;
		ins.bottom			= 5;
		ins.left			= 5;
		ins.right			= 5;
		gridcon.insets		= ins;
		gridbag.setConstraints(highChkBox,gridcon);

	/* das CardLayout-Panel wenn eine Transition selektiert ist */
		transitionPanel = new Panel3D(false);
		transitionPanel.setLayout(gridbag);
		gridcon.anchor		= GridBagConstraints.NORTH;
		gridcon.fill		= GridBagConstraints.BOTH;
		gridcon.weightx		= 0.0;
		gridcon.weighty		= 1.0;
		gridcon.gridx		= 0;
		gridcon.gridy		= 0;
		gridcon.gridwidth	= 1;
		gridcon.gridheight	= 1;
		ins.top				= 2;
		ins.bottom			= 2;
		ins.left			= 2;
		ins.right			= 2;
		gridcon.insets		= ins;
		gridbag.setConstraints(transitionPanel,gridcon);

		transLabel = new Label("Transition",Label.CENTER);
		transLabel.setFont(boldFont);
		gridcon.anchor		= GridBagConstraints.CENTER;
		gridcon.fill		= GridBagConstraints.HORIZONTAL;
		gridcon.weightx		= 1.0;
		gridcon.weighty		= 0.0;
		gridcon.gridx		= 0;
		gridcon.gridy		= 0;
		gridcon.gridwidth	= 1;
		gridcon.gridheight	= 1;
		ins.top				= 5;
		ins.bottom			= 0;
		ins.left			= 5;
		ins.right			= 5;
		gridcon.insets		= ins;
		gridbag.setConstraints(transLabel,gridcon);

		transField = new TextField(12);
		transField.setFont(plainFont);
		gridcon.anchor		= GridBagConstraints.NORTH;
		gridcon.fill		= GridBagConstraints.HORIZONTAL;
		gridcon.weightx		= 1.0;
		gridcon.weighty		= 1.0;
		gridcon.gridx		= 0;
		gridcon.gridy		= 1;
		gridcon.gridwidth	= 1;
		gridcon.gridheight	= 1;
		ins.top				= 5;
		ins.bottom			= 5;
		ins.left			= 5;
		ins.right			= 5;
		gridcon.insets		= ins;
		gridbag.setConstraints(transField,gridcon);

	/* das CardLayout-Panel wenn ein Kommentar selektiert ist */
		kommentarPanel = new Panel3D(false);
		kommentarPanel.setLayout(gridbag);
		gridcon.anchor		= GridBagConstraints.NORTH;
		gridcon.fill		= GridBagConstraints.BOTH;
		gridcon.weightx		= 0.0;
		gridcon.weighty		= 1.0;
		gridcon.gridx		= 0;
		gridcon.gridy		= 0;
		gridcon.gridwidth	= 1;
		gridcon.gridheight	= 1;
		ins.top				= 2;
		ins.bottom			= 2;
		ins.left			= 2;
		ins.right			= 2;
		gridcon.insets		= ins;
		gridbag.setConstraints(kommentarPanel,gridcon);

		kommentarLabel = new Label("Kommentar",Label.CENTER);
		kommentarLabel.setFont(boldFont);
		gridcon.anchor		= GridBagConstraints.CENTER;
		gridcon.fill		= GridBagConstraints.HORIZONTAL;
		gridcon.weightx		= 1.0;
		gridcon.weighty		= 0.0;
		gridcon.gridx		= 0;
		gridcon.gridy		= 0;
		gridcon.gridwidth	= 1;
		gridcon.gridheight	= 1;
		ins.top				= 5;
		ins.bottom			= 0;
		ins.left			= 5;
		ins.right			= 5;
		gridcon.insets		= ins;
		gridbag.setConstraints(kommentarLabel,gridcon);

		kommentarArea = new TextArea(5,5);
		kommentarArea.setFont(plainFont);
		gridcon.anchor		= GridBagConstraints.NORTH;
		gridcon.fill		= GridBagConstraints.BOTH;
		gridcon.weightx		= 1.0;
		gridcon.weighty		= 1.0;
		gridcon.gridx		= 0;
		gridcon.gridy		= 1;
		gridcon.gridwidth	= 1;
		gridcon.gridheight	= 1;
		ins.top				= 5;
		ins.bottom			= 0;
		ins.left			= 5;
		ins.right			= 5;
		gridcon.insets		= ins;
		gridbag.setConstraints(kommentarArea,gridcon);

		kommentarOK = new Button("bernehmen");
		kommentarOK.setFont(plainFont);
		gridcon.anchor		= GridBagConstraints.NORTH;
		gridcon.fill		= GridBagConstraints.HORIZONTAL;
		gridcon.weightx		= 1.0;
		gridcon.weighty		= 0.0;
		gridcon.gridx		= 0;
		gridcon.gridy		= 2;
		gridcon.gridwidth	= 1;
		gridcon.gridheight	= 1;
		ins.top				= 5;
		ins.bottom			= 5;
		ins.left			= 5;
		ins.right			= 5;
		gridcon.insets		= ins;
		gridbag.setConstraints(kommentarOK,gridcon);

	/* die Statuszeile ganz unten im Fenster */
		status = new Statuszeile("Zustnde mit der Maus verschieben");
		gridcon.anchor		= GridBagConstraints.CENTER;
		gridcon.fill		= GridBagConstraints.HORIZONTAL;
		gridcon.weightx		= 1.0;
		gridcon.weighty		= 0.0;
		gridcon.gridx		= 0;
		gridcon.gridy		= 4;
		gridcon.gridwidth	= 3;
		gridcon.gridheight	= 1;
		ins.top				= 5;
		ins.bottom			= 5;
		ins.left			= 5;
		ins.right			= 5;
		gridcon.insets		= ins;
		gridbag.setConstraints(status,gridcon);

	/* die Zeichenflche fr die FSM */
		editCanvas = new EditCanvas(fsm,this,status);
		gridcon.anchor		= GridBagConstraints.CENTER;
		gridcon.fill		= GridBagConstraints.BOTH;
		gridcon.weightx		= 1.0;
		gridcon.weighty		= 1.0;
		gridcon.gridx		= 1;
		gridcon.gridy		= 0;
		gridcon.gridwidth	= 1;
		gridcon.gridheight	= 3;
		ins.top				= 5;
		ins.bottom			= 2;
		ins.left			= 5;
		ins.right			= 2;
		gridcon.insets		= ins;
		gridbag.setConstraints(editCanvas,gridcon);

	/* die Scrollbars neben der Zeichenflche */
		HBar = new Scrollbar(Scrollbar.HORIZONTAL);
		gridcon.anchor		= GridBagConstraints.CENTER;
		gridcon.fill		= GridBagConstraints.HORIZONTAL;
		gridcon.weightx		= 1.0;
		gridcon.weighty		= 0.0;
		gridcon.gridx		= 1;
		gridcon.gridy		= 3;
		gridcon.gridwidth	= 1;
		gridcon.gridheight	= 1;
		ins.top				= 0;
		ins.bottom			= 5;
		ins.left			= 5;
		ins.right			= 5;
		gridcon.insets		= ins;
		gridbag.setConstraints(HBar,gridcon);

		VBar = new Scrollbar(Scrollbar.VERTICAL);
		gridcon.anchor		= GridBagConstraints.CENTER;
		gridcon.fill		= GridBagConstraints.VERTICAL;
		gridcon.weightx		= 0.0;
		gridcon.weighty		= 1.0;
		gridcon.gridx		= 2;
		gridcon.gridy		= 0;
		gridcon.gridwidth	= 1;
		gridcon.gridheight	= 3;
		ins.top				= 5;
		ins.bottom			= 5;
		ins.left			= 0;
		ins.right			= 5;
		gridcon.insets		= ins;
		gridbag.setConstraints(VBar,gridcon);

	/* jetzt noch alles zusammenbauen */
		buttonPanel.add(buttonMove);
		buttonPanel.add(buttonZustand);
		buttonPanel.add(buttonTransition);
		buttonPanel.add(buttonKommentar);
		buttonPanel.add(buttonDelete);
		buttonPanel.add(buttonStart);
//		buttonPanel.add(buttonPrint);
		button2Panel.add(buttonTest);
		nonePanel.add(noneLabel);
		zustandMealyPanel.add(zustMeLabel);
		zustandMealyPanel.add(zustMeField);
		zustandMealyPanel.add(signalListMe);
		zustandMealyPanel.add(outField);
		zustandMoorePanel.add(zustMoLabel);
		zustandMoorePanel.add(zustMoField);
		zustandMoorePanel.add(signalListMo);
		zustandMoorePanel.add(lowChkBox);
		zustandMoorePanel.add(highChkBox);
		transitionPanel.add(transLabel);
		transitionPanel.add(transField);
		kommentarPanel.add(kommentarLabel);
		kommentarPanel.add(kommentarArea);
		kommentarPanel.add(kommentarOK);
		dataPanel.add("None",nonePanel);
		dataPanel.add("ZustandMealy",zustandMealyPanel);
		dataPanel.add("ZustandMoore",zustandMoorePanel);
		dataPanel.add("Transition",transitionPanel);
		dataPanel.add("Kommentar",kommentarPanel);
		this.add(buttonPanel);
		this.add(button2Panel);
		this.add(dataPanel);
		this.add(editCanvas);
		this.add(HBar);
		this.add(VBar);
		this.add(status);
		setPanel(null);		// Daten-Panel initialisieren (CardLayout auf "nichts selektiert")
		setBars();			// Scrollbars setzen
	}

// **********************************************************************************************************************

	/** verarbeitet Events der Buttons, TextFields, etc. */
	public boolean action(Event event, Object arg) {
		if(event.target==buttonMove){				// "Bewegen"-Button gedrckt ?
			editCanvas.moveMode();
			buttonMove.setFont(boldFont);			// neuen Modus durch boldFont im Button anzeigen
			buttonZustand.setFont(plainFont);
			buttonTransition.setFont(plainFont);
			buttonKommentar.setFont(plainFont);
			buttonDelete.setFont(plainFont);
			buttonStart.setFont(plainFont);
			return true;
		}
		else if(event.target==buttonZustand){		// "Zustand"-Button gedrckt ?
			editCanvas.zustandMode();
			buttonMove.setFont(plainFont);
			buttonZustand.setFont(boldFont);		// neuen Modus durch boldFont im Button anzeigen
			buttonTransition.setFont(plainFont);
			buttonKommentar.setFont(plainFont);
			buttonDelete.setFont(plainFont);
			buttonStart.setFont(plainFont);
			return true;
		}
		else if(event.target==buttonTransition){	// "Transition"-Button gedrckt ?
			editCanvas.transitionMode();
			buttonMove.setFont(plainFont);
			buttonZustand.setFont(plainFont);
			buttonTransition.setFont(boldFont);		// neuen Modus durch boldFont im Button anzeigen
			buttonKommentar.setFont(plainFont);
			buttonDelete.setFont(plainFont);
			buttonStart.setFont(plainFont);
			return true;
		}
		else if(event.target==buttonKommentar){		// "Kommentar"-Button gedrckt ?
			editCanvas.commentMode();
			buttonMove.setFont(plainFont);
			buttonZustand.setFont(plainFont);
			buttonTransition.setFont(plainFont);
			buttonKommentar.setFont(boldFont);		// neuen Modus durch boldFont im Button anzeigen
			buttonDelete.setFont(plainFont);
			buttonStart.setFont(plainFont);
			return true;
		}
		else if(event.target==buttonDelete){		// "Lschen"-Button gedrckt ?
			editCanvas.deleteMode();
			buttonMove.setFont(plainFont);
			buttonZustand.setFont(plainFont);
			buttonTransition.setFont(plainFont);
			buttonKommentar.setFont(plainFont);
			buttonDelete.setFont(boldFont);			// neuen Modus durch boldFont im Button anzeigen
			buttonStart.setFont(plainFont);
			return true;
		}
		else if(event.target==buttonStart){			// "Startzustand"-Button gedrckt ?
			editCanvas.startMode();
			buttonMove.setFont(plainFont);
			buttonZustand.setFont(plainFont);
			buttonTransition.setFont(plainFont);
			buttonKommentar.setFont(plainFont);
			buttonDelete.setFont(plainFont);
			buttonStart.setFont(boldFont);			// neuen Modus durch boldFont im Button anzeigen
			return true;
		}
/*		else if(event.target==buttonPrint){
			PrintJob printjob = getToolkit().getPrintJob(this,"JavaFSM PrintJob",(Properties)null);
			if (printjob!=null) {
				Graphics g = printjob.getGraphics();
				Dimension dim = printjob.getPageDimension();
				editCanvas.drawFSM(0,0,dim.width,dim.height,g,null);
				printjob.end();
			}
			return true;
		} */
		else if(event.target==buttonTest){			// "Test"-Button gedrckt ?
			FSMtester fsmtester = new FSMtester(this, fsm);
			fsmtester.resize(400,300);
			fsmtester.show();
			fsmtester.resize(400,300);
			return true;
		}
		else if(event.target==kommentarOK){			// "bernehmen"-Button gedrckt ?
			((Kommentar)editCanvas.getSelected()).setText(kommentarArea.getText());
			editCanvas.repaint();
			return true;
		}
		else if((event.target==zustMeField)&&(editCanvas.getSelected() instanceof Zustand)) {// Return im Namen-TextField gedrckt ?
			String name = zustMeField.getText();
			if (!name.trim().equals("") && (name.indexOf(',')<0)) {
				boolean found = false;
				for (int i=0; i<fsm.zustaende.size(); i++)
					if (((Zustand)fsm.zustaende.elementAt(i)).name.equals(name)) found=true;
				if (!found) 
				{
					((Zustand)editCanvas.getSelected()).name = name;						// neuen Namen fr Zustand bernehmen
					editCanvas.repaint();
					status.set("");
				}
				else status.set("Name bereits vorhanden !");
			}
			else status.set("Name fehlerhaft !");
			return true;
		}
		else if((event.target==zustMoField)&&(editCanvas.getSelected() instanceof Zustand)) {	// Return im Namen-TextField gedrckt ?
			String name = zustMoField.getText();
			if (!name.trim().equals("") && (name.indexOf(',')<0)) {
				boolean found = false;
				for (int i=0; i<fsm.zustaende.size(); i++)
					if (((Zustand)fsm.zustaende.elementAt(i)).name.equals(name)) found=true;
				if (!found) 
				{
					((Zustand)editCanvas.getSelected()).name = name;						// neuen Namen fr Zustand bernehmen
					editCanvas.repaint();
					status.set("");
				}
				else status.set("Name bereits vorhanden !");
			}
			else status.set("Name fehlerhaft !");
			return true;
		}
		else if((event.target==outField)&&(editCanvas.getSelected() instanceof Zustand)) {	// Return im Output-TextField gedrckt ?
			int i = signalListMe.getSelectedIndex();														// fr welchen Output ?
			if (i >= 0) {
				((Zustand)editCanvas.getSelected()).outputHash.put(fsm.outputs.elementAt(i),outField.getText());	// neue Fkt. in Hashtable
				signalListMe.replaceItem(((Signal)fsm.outputs.elementAt(i)).name+"  -> "+outField.getText(),i);	// und in List-Box ndern
				signalListMe.select(i);																			// gleichen Output wieder selektieren
			}
			return true;
		}
		else if((event.target==lowChkBox)&&(editCanvas.getSelected() instanceof Zustand)) {	// low-Checkbox angeklickt ?
			int i = signalListMo.getSelectedIndex();														// fr welchen Output ?
			if (i >= 0) {
				((Zustand)editCanvas.getSelected()).outputHash.put(fsm.outputs.elementAt(i),"0");		// neue Fkt. in Hashtable
				signalListMo.replaceItem(((Signal)fsm.outputs.elementAt(i)).name+"  -> "+"0",i);		// und in List-Box ndern
				signalListMo.select(i);																			// gleichen Output wieder selektieren
				signalListMo.requestFocus();
			}
			return true;
		}
		else if((event.target==highChkBox)&&(editCanvas.getSelected() instanceof Zustand)) {	// high-Checkbox angeklickt ?
			int i = signalListMo.getSelectedIndex();														// fr welchen Output ?
			if (i >= 0) {
				((Zustand)editCanvas.getSelected()).outputHash.put(fsm.outputs.elementAt(i),"1");		// neue Fkt. in Hashtable
				signalListMo.replaceItem(((Signal)fsm.outputs.elementAt(i)).name+"  -> "+"1",i);		// und in List-Box ndern
				signalListMo.select(i);																			// gleichen Output wieder selektieren
				signalListMo.requestFocus();
			}
			return true;
		}
		else if((event.target==transField)&&(editCanvas.getSelected() instanceof Transition)) {	// Return im Fkt.-TextField gedrckt ?
			((Transition)editCanvas.getSelected()).function = transField.getText();				// neue Fkt. fr Transition bernehmen
			editCanvas.repaint();																				// durch repaint() einzeichnen
			return true;
		}
		else return super.action(event,arg);
	}

// **********************************************************************************************************************

	/** verabeitet Events der Scrollbars und der List-Boxen*/
	public boolean handleEvent(Event evt) {
		if (evt.id==Event.WINDOW_DESTROY) {						// Window schlieen ?
			this.hide();
			return true;
		}
		else if ((evt.id==Event.SCROLL_LINE_UP)||				// eine Scrollbar angeklickt ?
				 (evt.id==Event.SCROLL_LINE_DOWN)||
				 (evt.id==Event.SCROLL_PAGE_UP)||
				 (evt.id==Event.SCROLL_PAGE_DOWN)||
				 (evt.id==Event.SCROLL_ABSOLUTE)) {
			setBars();													// dann Werte verarbeiten
			editCanvas.repaint();									// und natrlich die FSM neu zeichnen
			return true;
		}
		else if((evt.id==Event.LIST_SELECT)&&(evt.target==signalListMe)&&(editCanvas.getSelected() instanceof Zustand)){	// ein Output in der List-Box selektiert ?
			if (signalListMe.getSelectedIndex() >= 0) {
				outField.setText((String)(((Zustand)editCanvas.getSelected()).outputHash.get(fsm.outputs.elementAt(signalListMe.getSelectedIndex()))));	// in TextField zeigen
				outField.requestFocus();							// und Cursor in TextField
			}
			else outField.setText("");								// falls nichts selektiert: TextField lschen
			return true;
		}
		else if((evt.id==Event.LIST_SELECT)&&(evt.target==signalListMo)&&(editCanvas.getSelected() instanceof Zustand)){	// ein Output in der List-Box selektiert ?
			if (signalListMo.getSelectedIndex() >= 0) {
				if ("1".equals((String)(((Zustand)editCanvas.getSelected()).outputHash.get(fsm.outputs.elementAt(signalListMo.getSelectedIndex())))))	// in TextField zeigen
					chkBoxGrp.setCurrent(highChkBox);
				else
					chkBoxGrp.setCurrent(lowChkBox);
			}
			return true;
		}
		else return super.handleEvent(evt);
	}

// **********************************************************************************************************************

	private void setBars() {											// die Werte der Scrollbars auslesen und verarbeiten
		Dimension d = editCanvas.size();
		HBar.setValues(HBar.getValue(),d.width,0,VirtWidth-d.width);
		VBar.setValues(VBar.getValue(),d.height,0,VirtHeight-d.height);
		editCanvas.xOffset = HBar.getValue();
		editCanvas.yOffset = VBar.getValue();
		HBar.setLineIncrement(50);									// diese Werte werden vom momentanen awt scheinbar ignoriert !
		VBar.setLineIncrement(50);
		HBar.setPageIncrement(100);
		VBar.setPageIncrement(100);
	}

// **********************************************************************************************************************

	/**
	* aktualisiert die Eigenschaften-Anzeige
	* @param selected Objekt (Zustand, Transition oder null), dessen Eigenschaften angezeigt werden sollen (Object)
	*/
	public void setPanel(Object selected) {						// je nach selektiertem Object das Detail-Panel setzen (CardLayout)
		if (selected instanceof Zustand) {
			if (mealy_machine) {
				card.show(dataPanel,"ZustandMealy");			// Panel fr Zustnde anzeigen
				zustMeField.setText(((Zustand)selected).name);
//				zustMeField.requestFocus();						// geht nicht!!! sonst scheinbar 2 mousedown-events !!!
				signalListMe.clear();							// List-Box lschen
				for (int i=0; i<fsm.outputs.size(); i++)		// und neu fllen (Reihenfolge ist wichtig !!!)
					signalListMe.addItem(((Signal)fsm.outputs.elementAt(i)).name+"  -> "+((Zustand)selected).outputHash.get(fsm.outputs.elementAt(i)));

				if (signalListMe.getSelectedIndex() >= 0)		// falls etwas selektiert ist im TextField zeigen, sonst TextField lschen
					outField.setText((String)(((Zustand)selected).outputHash.get(fsm.outputs.elementAt(signalListMe.getSelectedIndex()))));
				else outField.setText("");
			}
			else {
				card.show(dataPanel,"ZustandMoore");			// Panel fr Zustnde anzeigen
				zustMoField.setText(((Zustand)selected).name);
//				zustMoField.requestFocus();						// geht nicht!!! sonst scheinbar 2 mousedown-events !!!
				signalListMo.clear();							// List-Box lschen
				for (int i=0; i<fsm.outputs.size(); i++)		// und neu fllen (Reihenfolge ist wichtig !!!)
					signalListMo.addItem(((Signal)fsm.outputs.elementAt(i)).name+"  -> "+((Zustand)selected).outputHash.get(fsm.outputs.elementAt(i)));
			}
		}
		else if (selected instanceof Transition) {
			card.show(dataPanel,"Transition");					// Panel fr Transitionen anzeigen
			transField.setText(((Transition)selected).function);// zugehrige bergangs-Funktion im TextField eintragen
			transField.requestFocus();							// und Cursor holen
		}
		else if (selected instanceof Kommentar) {
			card.show(dataPanel,"Kommentar");					// Panel fr Kommentare anzeigen
			kommentarArea.setText(((Kommentar)selected).getText());// zugehrigen Text in TextArea anzeigen
//			kommentarArea.requestFocus();						// geht nicht!!! sonst scheinbar 2 mousedown-events !!!
		}
		else card.show(dataPanel,"None");						// Panel fr "nichts selektiert" anzeigen
	}


// **********************************************************************************************************************

	/**
	* setzt den Automaten-Typ
	* @param s String, der entweder "MOORE" oder "MEALY" enth&auml;lt
	*/
	public void setMachineType(String s) {
		if (s.toUpperCase().equals("MOORE")) 		mealy_machine = false;
		else if (s.toUpperCase().equals("MEALY"))	mealy_machine = true;
		setPanel((Zustand)editCanvas.getSelected());
		editCanvas.repaint();
	}

}
