/*****************************************************************/
/*                                                               */
/*          LoadFSM.c -- CGI-Programm fr JavaFSM                */
/*   von Ulrich Dallmann (2dallman@informatik.uni-hamburg.de)    */
/*   und Karola Krnert (2kroene@informatik.uni-hamburg.de)      */
/*                                                               */
/* Dieses Programm liest ber stdin vom WWW-Server einen File-   */
/* namen und ein Passwort.                                       */
/* Im Filenamen werden unerlaubte Zeichen durch ein '_' ersetzt  */
/* und die Endung '.fsm' angehngt. Ist im spezifizierten Pfad   */
/* (siehe "path") ein solches File vorhanden, wird das darin     */
/* enthaltene Passwort berprft und der neue Automat ggf. ber  */
/* stdout gesendet. Ist noch kein File unter diesem Namen        */
/* vorhanden oder traten beim Lesen Probleme auf, so wird eine   */
/* HTTP konforme Fehlermeldung generiert.                        */
/*                                                               */
/*****************************************************************/

#include <stdio.h>
#include <stdlib.h>

main() {
  FILE *fp;
  char c;
  unsigned long i;
  unsigned long start,length;

  char work[101];			/* zum Zwischenspeichern */
  char path[151] = "../fsm/";		/* um den Pfad zusammenzubauen */
  char name[101+4];			/* um den erhaltenen Namen zu merken */
  char passwd[101];			/* um das erhaltene Passwort zu merken */

  fgets(name, 101, stdin);		/* Zeile mit dem Dateinamen einlesen */
  fgets(passwd, 101, stdin);		/* Zeile mit dem Passwort einlesen */
  for (i=0; i<101; i++) {
    if (name[i]==10) name[i]=0;			/* <CR> ausfiltern */
    else if ( ((name[i]>0)&&(name[i]<48))||	/* alles bis zur '0',   */
              ((name[i]>90)&&(name[i]<97))||	/* zwischen 'Z' und 'a' */
               (name[i]>122) ) name[i]='_';	/* durch '_' ersetzen ! */
  }
  for (i=0; i<101; i++)
    if (passwd[i]==10) passwd[i]=0;		/* <CR> ausfiltern */
  strcat(path,name);				/* Filenamen an Pfad hngen */
  strcat(path,".fsm");				/* Endung noch anhngen */
  fp = fopen(path,"r");				/* Datei zum Lesen ffnen */
  if (fp!=NULL) {				/* wenn ok, dann ... */
    fgets(work, 100, fp);			/* erste Zeile einlesen */
    for (i=0; i<101; i++)
      if (work[i]==10) work[i]=0;		/* <CR> ausfiltern */
    if (strcmp(work,passwd)==0) {		/* Passwrter vergleichen */
      start = ftell(fp);			/* jetzige Lese-Position merken */
      fseek(fp,0L,2);				/* zum Datei-Ende */
      length = ftell(fp) - start;		/* Lnge des restlichen Files */
      fseek(fp,start,0);			/* zurck zur alten Position */

      printf("Content-type: text/plain\n");	/* HTTP Header */
      printf("Content-length: %ld\n\n",length+3); /* HTTP Header */
      printf("OK\n");				/* Rckmeldung: es folgen Daten */
      for (i=0; i<length; i++) {		/* restliche Zeichen senden: */
        c=fgetc(fp);				/* Zeichen lesen */
        fputc(c,stdout);			/* und senden */
      }
    }
    else {					/* Pawort ist falsch */
      printf("Content-type: text/plain\n");	/* HTTP Header */
      printf("Content-length: 18\n\n");		/* HTTP Header */
      printf("Passwort - Fehler\n");		/* Fehlermeldung */
    }
    fclose(fp);					/* Datei schlieen */
  }
  else {					/* konnte Datei nicht ffnen */
    printf("Content-type: text/plain\n");	/* HTTP Header */
    printf("Content-length: 15\n\n");		/* HTTP Header */
    printf("Datei - Fehler\n");			/* Fehlermeldung */
  }
  return 0;
}
