/*****************************************************************/
/*                                                               */
/*          SaveFSM.c -- CGI-Programm fr JavaFSM                */
/*   von Ulrich Dallmann (2dallman@informatik.uni-hamburg.de)    */
/*   und Karola Krnert (2kroene@informatik.uni-hamburg.de)      */
/*                                                               */
/* Dieses Programm liest ber stdin vom WWW-Server einen File-   */
/* namen, ein Passwort und eine Automatenbeschreibung.           */
/* Im Filenamen werden unerlaubte Zeichen durch ein '_' ersetzt  */
/* und die Endung '.fsm' angehngt. Ist im spezifizierten Pfad   */
/* (siehe "path") bereits ein File vorhanden, wird das darin     */
/* enthaltene Passwort berprft und der neue Automat ggf. ge-   */
/* speichert. Ist noch kein File unter diesem Namen vorhanden,   */
/* wird der Automat direkt gespeichert.                          */
/* Im Erfolgsfall wird "OK", ansonsten eine Fehlermeldung        */
/* zurckgegeben. Beides geschieht HTTP konform.                 */
/*                                                               */
/*****************************************************************/

#include <stdio.h>
#include <stdlib.h>

main() {
  FILE *fp;
  char c;
  int i;
  long length;

  char work[101];			/* zum Zwischenspeichern */
  char path[151] = "";		/* um den Pfad zusammenzubauen */
  char name[101+4];			/* um den erhaltenen Namen zu merken */
  char passwd[101];			/* um das erhaltene Passwort zu merken */
  int valid = 0;

  const char *str_len=getenv("CONTENT_LENGTH"); /* Anzahl der zu lesenden Bytes */
						/* ist in Umgebungsvariable */
  if (str_len!=NULL) {
    length=strtol(str_len,NULL,10);
    fgets(name,101, stdin);
    fgets(passwd,101, stdin);
    length -= (strlen(name)+strlen(passwd));
    for (i=0; i<101; i++) {
      if (name[i]==10) name[i]=0;
      else if ( ((name[i]>0)&&(name[i]<48))||	/* alles bis zur '0',	*/
                ((name[i]>90)&&(name[i]<97))||  /* zwischen 'Z' und 'a' */
                 (name[i]>122) ) name[i]='_';	/* durch '_' ersetzen ! */
    }
    for (i=0; i<101; i++)
      if (passwd[i]==10) passwd[i]=0; 		/* <CR> ausfiltern */
    strcat(path,name);				/* Filenamen an Pfad hngen */
    strcat(path,".fsm");			/* Endung noch anhngen */
    fp = fopen(path,"r");			/* Datei zum Lesen ffnen */
    if (fp!=NULL) {				/* wenn ok, dann ... */
      fgets(work, 100, fp);			/* erste Zeile einlesen */
      for (i=0; i<101; i++)
        if (work[i]==10) work[i]=0;		/* <CR> ausfiltern */
      if (strcmp(work,passwd)==0) valid=-1;	/* Passwort vergleichen */
      fclose(fp);				/* Datei schlieen */
    }
    else valid=-1;				/* wenn Datei nicht vorhanden */

    if (valid==-1) {				/* wenn soweit ok, dann */
      fp = fopen(path,"w");			/* zum schreiben ffnen */
      if (fp!=NULL) {				/* wenn ok, dann ... */
        fprintf(fp,"%s\n",passwd);		/* Passwort zuerst speichern */
        for (i=0; i<length; i++) {		/* dann restliche Daten: */
          fscanf(stdin, "%c", &c);		/* ein Zeichen lesen */
          fprintf(fp, "%c", c);			/* und gleich speichern */
        }
        if (fclose(fp)!=EOF) {			/* Datei schlieen & berprfen */
          printf("Content-type: text/plain\n");	/* HTTP-Header */
          printf("Content-length: 3\n\n");	/* HTTP-Header */
          printf("OK\n");			/* alles erfolgreich verlaufen */
        }
        else {					/* Speichern ist fehlgeschlagen */
          printf("Content-type: text/plain\n");	/* HTTP-Header */
          printf("Content-length: 17\n\n");	/* HTTP-Header */
          printf("Schreib - Fehler\n");		/* Fehlermeldung */
        }
      }
      else {					/* konnte Datei nicht ffnen */
        printf("Content-type: text/plain\n");	/* HTTP-Header */
        printf("Content-length: 15\n\n");	/* HTTP-Header */
        printf("Datei - Fehler\n");		/* Fehlermeldung */
      }
    }
    else {					/* Pawort ist falsch */
      printf("Content-type: text/plain\n");	/* HTTP-Header */
      printf("Content-length: 36\n\n");		/* HTTP-Header */
      printf("Datei vorhanden / falsches Passwort\n");	/* Fehlermeldung */
    }
  }
  else {					/* keine Umgebungsvariable */
    printf("Content-type: text/plain\n");	/* HTTP-Header */
    printf("Content-length: 43\n\n");		/* HTTP-Header */
    printf("CGI - Fehler\n");			/* Fehlermeldung */
    printf("CONTENT_LENGTH nicht gesetzt!\n");	/* noch Fehlermeldung */
  }
  return 0;
}
